.. -*- rst -*-

.. highlightlang:: none

News
====

.. _release-4-0-0:


Release 4.0.0 - 2014/02/09
--------------------------

* Bump version to 4.0.0!

Improvements
^^^^^^^^^^^^

* [normalizer] Supported to show "checks" which is used for calculating next character position.
  Use WITH_CHECKS flag to enable this feature.
* [deb] Dropped Ubuntu 13.04 support.

Fixes
^^^^^

* Fixed a crash bug that an object in grn_expr is used after it is freed.
  Normally Groonga server users aren't affected this bug. This bug mainly affects Rroonga users.
  Because this bug is occured by specifying column name including pseudo column name -
  such as '_key' - Rroonga users may use the usage.
* Fixed not to execute unexpected cascade delete which is introduced Groonga 3.0.8 release.
  If source's range and index's domain are different, Groonga doesn't execute cascade delete.
  [groonga-dev,02073] [Reported by yoku]
* Fixed not to publish grn_snip structure. Use grn_obj instead of grn_snip.
  If you use grn_snip_close, please replace grn_snip_close to grn_obj_close.
* [snippet_html] Fixed a crash bug when --query is empty.
  [groonga-dev,02097] [Reported by Naoya Murakami]
* [snippet_html] Fixed to suppress ALERT level message when contents of column is empty text.
  [groonga-dev,02097] [Reported by Naoya Murakami]
* [groonga-httpd] Fixed a bug "off" is used as path name in groonga_query_log_path.
  [groonga-dev,02113] [Reported by Ryoji Yamamoto]

Thanks
^^^^^^

* yoku
* Naoya Murakami
* Ryoji Yamamoto

.. _release-3-1-2:

Release 3.1.2 - 2014/01/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc] Updated to caplitalized "Groonga" terms in documentation. [Patch by cosmo0920] [GitHub#136, #137, #138, #139, #140, #141, #142, #143, #144, #145, #146, #147, #148, #149, #150, #151]
* Supported to customize the value of lock timeout. See :doc:`/reference/api/global_configurations` about details.
  [groonga-dev,02017] [Suggested by yoku]
* [doc] Added description about the value of lock timeout.
* Enabled ``GRN_JA_SKIP_SAME_VALUE_PUT`` by default. In the previous releases, the value of
  this configuration is 'no'. This change affects reducing the size of Groonga database.
* Supported multiple indexes including a nested index and multiple keywords query.
  This change improves missing search results isssue when narrowing down by multiple keywords query.
* Added API to customize normalizer for snippet.

Fixes
^^^^^

* Fixed not to use index for empty query. This change enables you to search even though empty query.
  Note that this means that there is performance penalty if many empty records exist.
  [groonga-dev,02052] [Reported by Naoya Murakami]
* Fixed the behaviour about return value of "X || Y" and "X && Y" for adjusting to ECMAScript.
  In "X || Y" case, if either X or Y satisfy the condition, it returns X itself or Y itself instead of 1 or 0.
* In "X && Y" case, if X and Y satisfy the condition, it returns X itself instead of 1.
  if X doesn't satisfy the condition, it returns false instead of 0.
* Fixed to return null when no snippet is found. This change enables you to set the default value
  of :doc:`/reference/functions/snippet_html`. In such a purpose, use "snippet_html(XXX) || 'default value'".

Thanks
^^^^^^

* cosmo0920
* yoku
* Naoya Murakami

.. _release-3-1-1:

Release 3.1.1 - 2013/12/29
--------------------------

Improvements
^^^^^^^^^^^^

* [deb] Refined Groonga packages for Debian policy. [groonga-dev,01930]
  [Suggested by Hideki Yamane]
* [deb] Dropped Debian 6.0 (squeeze) support.
* [deb] Dropped Ubuntu 10.04 (lucid) support.
* Supported :doc:`/reference/functions/geo_in_rectangle` in the whole world.
* Supported error report when failed to casting invalid value of geo point type.
* Exported some macros which is used for accessing pseudo column names.
  [groonga-dev,1999] [Suggested by whombx]
* [doc] Refined drilldown documentation. [Reported by @Yahppo]
* Supported :doc:`/reference/functions/between` function which is used for
  filtering the column value in specific range.
* [doc] Updated Travis CI environment information. [Patch by cosmo0920]
* [rpm][fedora] Dropped Fedora 19.
* [rpm][fedora] Supported Fedora 20.
* [doc] Updated "Groonga" notation. [Patch by cosmo0920] [GitHub#122, #123, #124, #125, #125, #126, #127, #128, #129, #130, #131, #131, #132, #133, #134]

Fixes
^^^^^

* [munin] Fixed the wrong port number which is specified for GQTP.
* [geo_in_circle] Fixed a bug that if you specify "LONGITUDExLATITUDE" as
  the 3rd argument of :doc:`/reference/functions/geo_in_circle`, Groonga crashes.

Thanks
^^^^^^

* Hideki Yamane
* whombx
* @Yappo
* cosmo0920

.. _release-3-1-0:

Release 3.1.0 - 2013/11/29
--------------------------

Improvements
^^^^^^^^^^^^

* [experimental] Supported an option to skip updating for the same value.
  It is enabled by setting GRN_JA_SKIP_SAME_VALUE_PUT=yes as environment variable.
* Improved to show tokenizer and original text in empty token warning message.
  It shows actual token, so it helps you to investigate token related issue.
* Dropped broken AIO support. [#2054] [Reported by sho MINAGAWA]
* [windows] Supported build with Visual Studio Express 2008. [#1964 the 21th comment]
  It is aimed to promote bundling Mroonga with MariaDB in the future.

Fixes
^^^^^

* Fixed a bug that type of "_value" column is treated as Int32.
  It causes the case that the value of "_value" column is casted unexpectedly.
  [Reported by Genki Takiuchi]
* Fixed to require GLib 2.14.0 or later for benchmark program.
  The benchmark program is changed to use GRegex which requires GLib 2.14.0 or later.
  It affects users who compile Groonga with '--enable-benchmark' configuration.
  [groonga-dev,01890] [Reported by WING]
* Fixed a memory leak on updating an empty column vector with the same value.
* Fixed a memory leak on updating index for column vector.
  It affects the case if you store the value of column which has invalid UTF-8 byte
  sequence.
* [plugin][windows] Fixed the issue that register command fails without
  'lib/groonga/plugins'. [Reported by @yito]

Thanks
^^^^^^

* sho MINAGAWA
* Genki Takiuchi
* WING
* @yito

.. _release-3-0-9:

Release 3.0.9 - 2013/10/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc][httpd] Added documentation about :ref:`groonga-database-auto-create` directive.
* [httpd] Added :ref:`groonga-cache-limit` directive.
* [doc] Added description why zlib/lzo compression are disabled by default. [groonga-dev, 01845] [Suggested by Naoya Murakami]  
* Remove a restriction related to RLIMIT_NOFILE on HTTP server.
  It enables HTTP server process to handle over 4096 files.
* [experimental] Added some API to integrate mruby into groonga. [GitHub#109, #110, #111, #112, #113, #114, #115, #116, #117, #118] [Patch by wanabe]
* [travis] Supported CMake build on Travis-CI.
* [doc] Added documentation about :doc:`reference/tuning`.
* [experimental] Added :doc:`ruby_load` command.
* [httpd] Supported multiple buffered body of POST request.
  The load command caused timeout in such a case. [GitHub #120] [Patch by Motoi Washida]
* [gqtp] Supported error message. The body is changed to return
  raw text insted of double quoted text. This is incompatible changes.
* [http] Supported "400 Bad request" for invalid argument error.
* [doc] Added examples for :doc:`/suggest/completion`
* Supported Ubuntu 13.10 (Saucy Salamander).

Fixes
^^^^^

* Fixed a bug that it cause SEGV by arithmetic overflow.
  This problem occurs when the size of indexes exceeds
  the size of virtual memory. [groonga-dev,01661]
  [Reported by Naoya Murakami]
* Fixed needless lock for creating table.
  This change fixes a performance regression instroduced at Groonga 3.0.5.
* Fixed a bug that database which has reference column can't be removed.
  It affects the case that indexed tables/columns and referenced tables
  are removed at first, then remove operation to index columns and
  reference columns fails. [Reported by Eito Katagiri] [GitHub Rroonga #13]
* Fixed a bug that removing database which uses DAT key may remain garbage.
* [http] Fixed a small memory leak which is caused by shared HTTP header buffer in the same worker thread.
* [httpd] Fixed a bug that :ref:`groonga-database-auto-create` parameter
  isn't inherited. It means that these parameters are just ignored in non location blocks.
* Fixed a bug that status command may returns invalid cache hit rate.
* Fix a bug that casting to Time may causes overflow issue.
  It affects the case that assignment of the Time value which indicate over 32bit value.

Thanks
^^^^^^

* Naoya Murakami
* wanabe
* Motoi Washida
* Eito Katagiri

.. _release-3-0-8:

Release 3.0.8 - 2013/09/29
--------------------------

Improvements
^^^^^^^^^^^^

* [admin] Improved error handling of select functionality. This change shows error message
  and hides loading dialog. [Patch by orangain]
* [admin] Improved to submit search form with the enter key. [Patch by orangain]
* [admin] Improved to show placeholder in search form.
  This change shows usage examples. [Patch by orangain]
* [httpd] Supported :ref:`groonga-query-log-path` directive
* [doc] Updated :doc:`/reference/commands/select` documentation about the number of
  hits in select response.
* Improved to ignore an empty token which is generated by continuous spaces from tokenizer.
  [groonga-dev,01729] [Suggested by Naoya Murakami]
* [token delimit] Improved to treat continuous spaces as a space.
  The tokenizer regards 2 or more spaces are valid input.
* [doc] Added note about indexes for each column vs indexes for multiple column.
* [doc] Added language annotation to source label. [groonga-dev,01751] [Suggested by Kazuhiro Isobe]
* Supported :ref:`cascade-delete` to referenced records. In previous version,
  You got an error for the operation.
* [doc] Updated documentation location in README. [groonga-dev,01800] [Reported by Kazuhiro Isobe]
* [experimental] Added :doc:`/reference/commands/ruby_eval` command.
* [doc] Added note about GQTP and HTTP for server use. [groonga-dev,01810] [Reported by Kazuhiro Isobe]

Fixes
^^^^^

* [admin] Fixed a bug that add value button of COLUMN_VECTOR does not work.

Thanks
^^^^^^

* orangain
* Naoya Murakami
* Kazuhiro Isobe

.. _release-3-0-7:

Release 3.0.7 - 2013/08/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc] Added API documentation. [groonga-dev,01593]
  [GitHub#79,#80,#81,#82,#83,#84,#85,#86,#87,#88,#89,#90,#91,#92,#93,#95,#96,#97,#98,#99,#100]
  [Patch by whombx]
* [table_remove] Improved not to remove patricia trie table or hash table
  which is still referenced. This change avoids that referenced table is removed accidentally.
* Improved to just ignore too long token (4096 bytes or more).
  This change affects when it is registered. In the previous version, it is treated as an
  error instead of a warning. [groonga-dev,01571] [Suggested by Naoya Murakami]
* Improved to show actual discarded posting term in log message.
  [groonga-dev,01621] [Reported by Naoya Murakami]
* [httpd] Supported loading data using POST method. [GitHub#101]
  [Patch by Motoi Washida]
* [httpd] Supported groonga log as ``groonga_log_path`` directive.
* [httpd] Supported groonga log level as ``groonga_log_level`` directive.
* [httpd] Supported customizing cache limit as ``groonga_cache_limit`` directive.

Fixes
^^^^^

* Fixed a bug that error in expression may cause stack overflow.
  This change avoids that groonga crashes suddenly as a result of error accumlation.
* Fixed a crash bug that offline index construction for vector column which has
  orphan reference causes.
* Fixed a bug that groonga doesn't exit on error while daemon mode starts.
  For example, ``groonga -d /tmp/non-existence.db`` reproduce this bug.
* [dump] Fixed a bug that wrong table type is dumped.
  This bug occurs when table type is TABLE_PAT_KEY and key is reference type.
* Fixed a bug that the default ``--cache-limit`` value is 0.
  The default value is changed to '100'.
* Fixed a memory leak when :doc:`/reference/functions/sub_filter` is used.
* [doc] Fixed description of defrag command. [Reported by @naoina]
* [doc] Fixed description about the way to contribute. [GitHub#77]
  [Patch by Masafumi Yokoyama]
* [plugin] Fixed a crash bug on multiple DB open case.
  This bug affects the case that multiple plugin is used and the same database is opened from
  multiple process. [groonga-dev,01596] [Reported by Naoya Murakami]
* Fixed a bug that nested match operation after ``AND`` operator doesn't work.
  The ``select ... --filter '... && nested.column @ "keyword"'`` query reproduces this bug.
  [groonga-dev,01599] [Reported by Motoi Washida]
* [doc] Fixed a typo about documentation of special characters.
  [Reported by Genki Takiuchi]
* Fixed a typo in error message when invalid character is given.
  [Reported by YOSHIDA Mitsuo]

Thanks
^^^^^^

* whombx
* @naoina
* Masafumi Yokoyama
* Motoi Washida
* Genki Takiuchi
* YOSHIDA Mitsuo

.. _release-3-0-6:

Release 3.0.6 - 2013/07/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc] Added documentation about parameter of :doc:`/reference/functions/sub_filter`
  function.
* [suggest] Supported 0MQ 3.x. [GitHub#63] [Reported by Naoya Inada]
* Added availability check for NetBSD about ``pthread_{mutex,cond}attr_setpshared()``
  [Reported by OBATA Akio]
* Supported backslash escape in query syntax. [groonga-dev,01520]
  [Reported by Kouhei Tanabe]
* [rpm][fedora] Supported Fedora 19.
* [rpm][fedora] Dropped Fedora 18 support.
* [httpd] Updated bundled nginx version to 1.4.2.

Fixes
^^^^^

* Fixed a crash bug when specific internal function (``grn_obj_path()``) is called
  for built-in proc function such as ``select``. [Reported by Genki Takiuchi]

Thanks
^^^^^^

* Naoya Inada
* OBATA Akio
* Kouhei Tanabe
* Genki Takiuchi

.. _release-3-0-5:

Release 3.0.5 - 2013/06/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc] Added summary about ``match_columns`` and ``query_string`` parameters in ``query()``.
* Added subrecord information to table inspection.
* Supported single quoted string literal in ``output_columns`` expression.
  This means that "XXX, '...'" expression is supported.
* [doc] Added notification about root privileges and well known port
  when starting groonga server. [Reported by Kosuke Asami]
* [experimental] Added :doc:`/reference/functions/html_untag` function.

Fixes
^^^^^

* Fixed a crash bug of mroonga which is caused by missing lock for table creation.
  [Reported by Y.Kentaro]
* Fixed a lot of compilation warnings by clang and gcc.
* Fixed a bug that ``sub_filter(...)`` is ignored if you use "XXX && sub_filter(...)"
  expression.
* Fixed a bug that wrong tag name is used in XML output.
  This bug affects the case if you use "REFERENCE_VECTOR_COLUMN._key" expression
  for ``output_columns``. Reference column isn't contained in XML ouput.
* [doc] Fixed wrong arguments in ``sub_filter()`` documentation.
* [deb] Fixed a bug that status action returns wrong exit code
  when services are stopped. [GitHub#62] [Patch by @orangain]
* Fixed a bug that the value of arithmetic operation is broken.
  This bug affects the case if you assign calculated value to
  ``_score`` pseudo column for example.

Thanks
^^^^^^

* Y.Kentaro
* Kosuke Asami
* @orangain

.. _release-3-0-4:

Release 3.0.4 - 2013/05/29
--------------------------

Improvements
^^^^^^^^^^^^

* [tokenizer] Improved to show log message when normalized string is not given.
* Supported ``_key`` as an argument of ``geo_in_circle``. [Reported by @ceekz]
* Supported to cast vector elements when groonga is used as a library.
* Dropped Ubuntu 11.10 (Oneiric Ocelot) support.
* Supported multiple index section in ``match_columns``.
* Supported ``tokenize`` command.
* Supported to show system error message when ``mmap()`` is failed.
* [doc][windows] Simplified build procedures by "cmake --build".
* Improved to restrict max execution time to prevent hanging service script.
  [GitHub#61] [Reported by firewood]
* Supported to evaluate vector as boolean.
  By this change, empty vector is evaluated as true.
* Improved not to log too many needless log messages.
  Too many log messages are truncated as "(N same messages are truncated)".
* [munin][groonga_n_records] Added ``exclude_tables`` option.
  It supports to exclude specific tables from monitoring results.
* Supported Debian 8.0 (jessie).
* Improved database portability by eliminating directory path of
  system plugins.

Fixes
^^^^^

* [tokenizer] Fixed a memory leak on error.
* Fixed a bug that empty string for similar search causes SEGV.
  [groonga-dev,01346] [Reported by Nakai Kanako]
* Fixed a memory leak when "VECTOR_COLUMN != xxx", "VECTOR_COLUMN && xxx"
  expressions are used.
* Fixed a bug that SIGSTOP and SIGCONT stops groonga server.
* Fixed a crash bug when normalizer returns NULL as normalized string.
  [Reported by Y.Kentaro]
* Fixed a bug that daemonize process doesn't work on OS X.
  [groonga-dev,01440] [Reported by Masahiro KONISHI]
* [deb] Fixed a bug that HTTP/GQTP process is excuted as root user.

Thanks
^^^^^^

* @ceekz
* Nakai Kanako
* firewood
* Y.Kentaro
* Masahiro KONISHI
* @orangain

.. _release-3-0-3:

Release 3.0.3 - 2013/04/29
--------------------------

Improvements
^^^^^^^^^^^^

* [suggest] Supported to learn with the value of customized weight
  by using ``configuration.weight`` configuration.
* Improved performance of geo-location search. For example,
  ``geo_in_rectangle`` is executed about 10% faster than ever.
* [rpm][centos] Added ``additional_configure_options`` parameter
  for building customized groonga without changing spec file.
* Supported KyTea 0.4.5.
* Supported vector index access by "vector[N]" syntax.
* Added ``--default-tokenizer`` option to :doc:`/reference/executables/groonga-suggest-create-dataset` command.
* Added ``--help`` option to :doc:`/reference/executables/groonga-suggest-create-dataset` command.
* Supported Ubuntu 13.04 Raring Ringtail.

.. _release-3-0-2:

Release 3.0.2 - 2013/03/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported two or more indexes for a table key.
  This change affects to eliminate potential crash case when loading a new key
  to two or more indexed key.
* Supported binary operations such as ``X + Y``, ``X - Y``, ``X * Y``, ``X / Y``,
  ``X % Y``, ``X >> Y``, ``X << Y``, ``X | Y``, ``X ^ Y``, ``X & Y`` and ``X >>> Y``
  for Int8, UInt8, Int16, UInt16 and UInt64.
* Added english documentation for ``load`` command.
* Supported binary assign operations such as ``X += Y``, ``X -= Y``, ``X *= Y``,
  ``X /= Y``, ``X %= Y``, ``X <<= Y``, ``X >>= Y``, ``X >>>= Y``, ``X &= Y``,
  ``X |= Y`` and ``X ^= Y`` for Int8, UInt8, Int16, UInt16 and UInt64.
* Supported unary operations such as ``-X`` for Int8, UInt8, Int16, UInt16 and UInt64.
* Supported complex string concatination in ``--output_columns``.
  For example, you can use a query such as ``--output_columns '"<" + title + ">"'``.
* Added the information of the repository of groonga to development page.
* Added ``sub_filter()`` function.
* Supported query expander in ``query()`` function.
  This change supports the query such as
  ``query("MATCH_COLUMNS", "QUERY", "QueryExpanderTSV")``.
* Renamed ``--query_expansion`` to ``--query_expander``.
  ``--query_expansion`` is regarded as deprecated.

Fixes
^^^^^

* Fixed a bug that ``snippet_html(XXX), XXX`` fails with "stack error".
  This bug affects a query such as ``--output_columns 'snippet_html(title), content'``.
  [Groonga-talk (no subject)] [Reported by Hendro Wibowo]
* Fixed a typo about install documentation. [Reported by hino]
* Fixed a bug that Travis-CI setup script fails.
  [groonga-dev,01248] [Reported by ongaeshi]
* Fixed a memory leak.
  This bug affects the case which satisfy following three conditions.
  Column is a reference column, Column is a vector column and
  Reference key size is 25 byte or lager.
* Fixed a crash bug by ``--output_columns _score.GARBAGE``.
  This affects the case if GARBAGE does not exist.

Thanks
^^^^^^

* Hendro Wibowo
* hino
* ongaeshi

.. _release-3-0-1:

Release 3.0.1 - 2013/02/28
--------------------------

Improvements
^^^^^^^^^^^^

* Supported to set Bool to reference column when loading dataset by load command.
* Supported AND operation for nested index.
  In this change, the expression "COLUMN1.COLUMN2 >= 1 && COLUMN1.COLUMN2 <=3" works.
  Note that the order is important for this expression.
  "1 <= COLUMN1.COLUMN2" is not supported yet. It is regarded as "COLUMN1.COLUMN2 <= 1".
* Supported sorting not indexed entries.
  This change affects the case such as ``--sortby geo_distance(...)`` drops not indexed
  entries.
* Supported range search for reference column by index.
  This change enable you to search range by index which is TABLE_PAT_KEY or TABLE_DAT_KEY
  based nested index of _key.
* [rpm][centos] Supported MeCab 0.995.
* [doc] Added missing documentation of commands such as ``column_rename`` or ``truncate``.

Fixes
^^^^^

* Fixed a bug that ``grn_index_cursor_next()`` returns NULL unexpectedly.
  It causes that invalid index entry is returned after deleting entries.
  This bug affects mroonga in storage mode. [groonga-dev,01192] [Reported by b senboku]
* Fixed a crash bug that ``geo_distance()`` sort by index.
  This bug occurs by wrong the number of found records.
* [httpd] Enabled default owner/group of database setting as groonga/groonga.

Thanks
^^^^^^

* b senboku


.. _release-3-0-0:

Release 3.0.0 - 2013/02/09
--------------------------

* Bump version to 3.0.0!

Fixes
^^^^^

* [deb] Fixed to install missing not EUC-JP, but UTF-8 encoding dictionary
  when ``groonga-tokenizer-mecab`` package is installed.
* Fixed a bug that int64 literal is truncated to uint32 value.
  If you use string literal for int64, this bug does not affects.
* [rpm][centos] Fixed a bug that stopping ``groonga-server-http`` service
  by init script is failed. [GitHub#53] [Patch by IWAI, Masaharu]

Thanks
^^^^^^

* IWAI, Masaharu

.. _release-2-1-2:

Release 2.1.2 - 2013/01/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported multiple ``query()`` in a select command.
  For example, you can specify the keyword which has different weight such as
  'query("column * weight1", keyword1) || query("column * weight2", keyword2) || ...'
  for ``--filter``.
* Dropped experimental view feature.
* Added ``grn_logger_reopen`` API for custom logger.
  Note that ``grn_logger_info`` API is deprecated, use ``grn_logger`` API instead.
* Added ``grn_default_logger_set_path()`` and ``grn_default_logger_get_path()`` API.
  Note that global ``grn_log_path`` variable was removed. Use above API.
* Added ``grn_default_query_logger_set_path()`` and
  ``grn_default_query_logger_get_path()`` API.
  Note that global ``grn_qlog_path`` variable was removed. Use above API.
* Added translated documentation about :doc:`/reference/tables` and :doc:`/reference/normalizers`.
* [deb][rpm] Improved to install with missing dictionary when
  ``groonga-tokenizer-mecab`` package is installed.
* Supported :ref:`nested-index-search` with range search.
  For example, you can specify 'column1.column2...columnN <= "1988-01-04 00:00:00"'
  in ``--filter``.
* [rpm][fedora] Supported Fedora 18.
* [rpm][fedora] Dropped Fedora 17 support.
* [doc] Added documentation for :doc:`/server/package`.
* [doc] Added documentation for :doc:`/reference/functions/query`.

Fixes
^^^^^

* Fixed not to report an error even though MeCab tokenizer shared object
  isn't found. [groonga-dev,01174] [Reported by wing]
* [httpd] Fixed not to fail configure on CentOS 5.4 by setting
  ``SED`` variable explicitly.
* Fixed a crash bug that not initialized vector column value is accessed
  by select command.

Thanks
^^^^^^

* wing

.. _release-2-1-1:

Release 2.1.1 - 2012/12/29
--------------------------

This is bug fix release of 2.1.0. All of 2.1.0 users should use 2.1.1
instead.

Fixes
^^^^^

* Fixed a bug that ``KEY_NORMALIZE`` information in database that is
  created by groonga 2.0.8 or ealier is dropped.

.. _release-2-1-0:

Release 2.1.0 - 2012/12/29
--------------------------

.. Caution::

   Use 2.1.1 instead of 2.1.0. 2.1.0 has a serious bug related
   ``KEY_NORMALIZE``.

.. Caution::

   This release has backward incompatible changes against ``table_list`` and
   ``column_list`` commands. If you use own program which depends on the output
   results above commands, you need to support null instead of "null" string.

   This release has supported ``--normalizer`` option, but there is
   side effect for this feature. If you open old version of groonga
   database at least once, you can not open its database by old
   version of groonga.

   There is also another backward incompatible change agaist plugin API for
   tokenizer. The argument of ``grn_tokenizer_query_open`` API has changed.
   This API change affects developer of tokenizer plugin.

Improvements
^^^^^^^^^^^^

* [doc] Added documentation about :ref:`nested-index-search`.
* Supported the expression as :doc:`/reference/functions/snippet_html` arguments.
  This change enables you to use ``snippet_html("STRING" + "STRING")`` for example.
  You can specify column name or literal for "STRING". [Reported by Tomoatsu Shimada]
* Supported to create own normalizer as a plugin.
* Moved ``groonga-query-log-analyzer`` as
  `groonga-query-log <http://rubygems.org/gems/groonga-query-log>`_ RubyGems.
  It enables you to analyze query logs without installing groonga package.
* Supported ``--normalizer`` option for :doc:`/reference/commands/table_create` command.
  This change enables you to specify normalizer plugin.
* Changed "null" string to null value as meaning for "No Object".
  This is backward incompatible change and affects output results of introspection
  related commands such as ``table_list`` and ``column_list``.
* Added a flag which controls behavior about normalizer as the last argument
  of ``grn_tokenizer_query_open`` API.
* Supported continuous line in :ref:`command-list-with-continuous-line` list.
* Improved to support not only no key table, but also hash table, patricia trie
  and double array trie for :ref:`nested-index-search`.

Fixes
^^^^^

* [windows] Added missing ``O_BINARY`` flag to open file correctly.
  This change fixes the infinite loop problem about groonga HTTP server.
  [GitHub#47] [Patch by Shimomura Tatsuya]
* Fixed a bug that ``--default-match-escalation-threshold`` doesn't accept
  negative value to disable functionality.
  This fix enable you to disable search escalation.
  see :option:`--default-match-escalation-threshold` about details.
* Fixed a bug that ``_score`` after "*" is ignored in ``--output_columns``.

Thanks
^^^^^^

* Tomoatsu Shimada
* Shimomura Tatsuya

.. _release-2-0-9:

Release 2.0.9 - 2012/11/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported to calculate the value of distance accross border
  in ``geo_distance`` with ``rectangle`` as approximate type. [#1534]
* [doc] Added the :doc:`/spec/gqtp` specification.
* Improved to ignore non critical ``getaddrinfo()`` error which groonga command emits on startup.
  This change does not affects nomal use of groonga because it just checked whether default hostname
  is resolved in previous version.
* [experimental] Added ``snippet_html()`` function which extract keyword and surrounding text.
  See :doc:`/reference/functions/snippet_html` about details.
* Supported to report error reason when error occured during reading table record.
* Supported to search with keyword by nested index notation ( concatinate multiple 
  indexed column name with dot character ) if there is a relationship between
  multiple table with index.
* Supported to log "[tokenizer][mecab]" tag when using ``TokenMecab`` tokenizer.
* Supported to log "[tokenizer][kytea]" tag when using ``TokenKyTea`` tokenizer.
* Improved to use separated array for command error location as output results.
  This change is incompatibility change, but does not affects existing program.
* Added documentation for :doc:`/reference/command/output_format`.
* Added documentation for :doc:`/reference/command/return_code` of output results.
* Supported range search by using index.

Fixes
^^^^^

* Fixed to use network byte order for status code of :ref:`gqtp-header-spec` to follow
  the normal network protocol convention.
  This change affects that groonga <= 2.0.8 client which connects to groonga server 2.0.9
  or later can not show status code properly when command failed.
* Fixed a bug that UTF-8 normalization computes wrong offset which affects to return value
  of ``snippet_html()``. This change not to insert tag of snippet into invalid location.
  [#1531] [Reported by Tomoatsu Shimada]
* [windows] Fixed over allocated memory access which cause segmentation fault
  on startup by groonga command. [#1532] [Patch by Akio Tajima]
* [windows] Fixed a bug that data stored in column couldn't be read when total amount of data
  stored in column exceeds 128MB. [groonga-dev,01088] [Reported by ongaeshi]
* Fixed a bug that searching with indexed column for ``Int*`` and ``UInt*`` 
  except ``Int32/Uint32`` returns invalid results.
* Fixed a bug that deleting record can be found.
* Fixed a bug that latin1 and koi8r normalizations could not process all string data
  if given string contains NULL character on the way.
* Fixed to return the correct default value of type when no data stored in column is
  referenced by ``select`` command.
* Fixed to exclude the value of vector column metadata in :ref:`offline-index-construction`.
  This change not to contain such a metadata as search results.

Thanks
^^^^^^

* Tomoatsu Shimada
* Akio Tajima
* ongaeshi


.. _release-2-0-8:

Release 2.0.8 - 2012/10/29
--------------------------

Improvements
^^^^^^^^^^^^

* [rpm] Improved the description of server-http and httpd packages.
  [Suggested by Daiki Ueno]
* Supported custom query expansion by plugin.
* [experimental] Added query expander ``QueryExpanderTSV`` plugin.
* Supported Ubuntu 12.10 Quantal Quetzal
* [experimental] Supported function call in ``output_columns``.
* [doc][rpm] Add missing description about installing MeCab dictionary.
  [Reported by serihiro]

Fixes
^^^^^

* [rpm] Fixed to remove needless "Requires" from spec file.
  [Reported by Daiki Ueno]
* [rpm] Fixed inaccurate description about license of groonga-server-gqtp.
* [admin] Fixed record edit button shows wrong record. [GitHub#34]
  [Reported by firewood]
* [deb] Fixed to remove needless dependency to pcre.
* [deb] Fixed to bundle missing table plugin.

Thanks
^^^^^^

* Daiki Ueno
* firewood
* serihiro

.. _release-2-0-7:

Release 2.0.7 - 2012/09/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc] Added more descriptions about ``--query_flags``.
* [doc][httpd] Added sample configuration for gzip compression.
* [httpd][rpm][centos] Added groonga-httpd init script.
* [rpm] Added logrotate config files.
* Supported creating database during install process.
* [httpd] Supported ``groonga_database_auto_create`` directive.
* Supported score respected merge by set operation. [GitHub#31]
* [httpd] Supported ``load`` command by POST.
* Added error check for creating temporary result set. [GitHub#33]
* Added GQTP server package.
* Added ``max()`` function.
* Added ``min()`` function.

Fixes
^^^^^

* Fixed to set domain to vector elements to ``load`` command. [GitHub#30]
* [httpd] Fixed missing NULL initialization. [Reported by @Kiske]
* [httpd] Fixed missing size about ``content_type_len``.
* [rpm][fedora] Fixed to use ``--bind-address`` in ``groonga.service``.
* Fixed crash by invalid argument filter. [GitHub#32]
* Fixed a bug that Time -> Time cast breaks value.
* Fixed a bug that Time -> Float cast breaks value.

Thanks
^^^^^^

* @Kiske

.. _release-2-0-6:

Release 2.0.6 - 2012/08/29
--------------------------

Improvements
^^^^^^^^^^^^

* [deb][rpm] Added ``groonga-server-common`` meta package. [#1451]
* Supported ``--query_flags`` option to ``select`` command.
* Supported PCRE auto detection for groonga-httpd.
* [doc] Added information about Twitter and Facebook.
* Improved to show error message from MeCab on ``mecab_new2()`` failure.
* [doc] Added details about groonga for server use.
* Improved to log details about ``vm.overcommit_memory``.
* Supported custom selector definition.
* Supported ``--working-directory`` option for groonga.
* Supported ``dump`` command for groonga-httpd.
* Improved to show not found target name for ``clearlock`` command.
* Improved error messages about ``get`` command implemented by table plugin.
* [rpm][centos] Supported MeCab 0.994. [#1455]
  [Suggested by IWAI, Masaharu]
* Supported changing default logger's max level before ``grn_init()``.
* Added ``all_records()`` function which copies all record IDs to the result table.
* Supported '-WORD' in ``--query`` of the select command.

Fixes
^^^^^

* [doc] Fixed the execution examples. [#1428]
  [Reported by IWAI, Masaharu]
* [deb] Fixed not to force groonga user/group by init script for groonga-httpd.
* [rpm][fedora] Fixed missing stop parameter for groonga-httpd service.
* Fixed a bug that the last 1 byte for cache key is ignored by ``select`` command.
* Fixed detection of the number of arguments in the complex function call.
* Fixed to suppress a warning by Clang.
* Fixed backward incompatibility about missing ``add`` command related error
  by executing ``clearlock`` command.
* [windows] Fixed database open failure which is related to binary data.
  [Reported by @yito]

Thanks
^^^^^^

* IWAI, Masaharu
* @yito


.. _release-2-0-5:

Release 2.0.5 - 2012/07/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported calculating the value of distance with "rect" or "rectangle"
  argument in southern hemisphere. [#1418] [#1419] [#1420] [#1421]
* [doc] Added some literals description in script syntax.
* Supported other directory build for groonga-suggest and groonga-httpd.
* Supported ";" as a query parameter separator. [#1406]
  [Suggested by IWAI, Masaharu]
* [doc] Added descriptions about script syntax.
* Supported near search by ``'column *N "word1 word2 ..."'`` in script syntax.
  [#1423]
* [doc] Added a description about limitation of suffix search.
* Supported near search for ``_key`` pseudo column. [GitHub#19]
* [doc] Added basic ECMAScript related syntaxes.
* [doc] Updated a description about :doc:`/reference/functions/geo_distance`.
* [rpm][fedora] Supported Fedora 17.
* [rpm][fedora] Dropped Fedora 16 support.
* Supported logical not ``"!"`` operator. [GitHub#22]
* [httpd] Supported per location groonga database.
* Improved to return error messages while load command is processing.
* Improved to exit load command when an uncontinuable error occurred.
* Improved to stop load command for invalid --columns value.
* Supported to open locked database. [GitHub#21]

Fixes
^^^^^

* Fixed a build problem about groonga-httpd on Mac OS X.
  [Reported by SHIMADA Koji]
* Fixed not to use installed groonga's header files for groonga-httpd.
* Fixed a build problem about groonga on Mac OS X Lion.
* [doc] Fixed a description of :doc:`/reference/commands/table_remove` command.
* Fixed infinite loop problem for not implemented operator without index.
  [GitHub#20]
* Fixed a wrong error code which causes memory leaks.
* Fixed a wrong error code which collapse ja columns.
* [admin] Fixed to escape error message.
* Fixed to ignore unloadable objects which causes database incompatible.
  [#1429] [Reported by IWAI, Masaharu]

Thanks
^^^^^^

* SHIMADA Koji
* IWAI, Masaharu


.. _release-2-0-4:

Release 2.0.4 - 2012/06/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported only KyTea 0.4.2.
* Dropped KyTea 0.4.1 or ealier support.
* [experimental] Supported nginx based groonga HTTP interface.
* Supported calculating the value of distance with "rect" or "rectangle"
  argument in northern hemisphere. [#1386] [#1387] [#1388] [#1389]
* [doc] Added a document about :doc:`/development/travis-ci` integration.
* [doc] Added descriptions about full text search and phrase search.
  See :ref:`full-text-search-condition` and :ref:`phrase-search-condition`
  about detail.
* [doc] Added descriptions about comparison conditions.
  See :ref:`conditional-expression` about detail.
* [doc] Added examples for :doc:`/reference/grn_expr/query_syntax`.
* [doc] Added descriptions about :ref:`combined-expression`.
* [doc] Added descriptions about :ref:`prefix-search-condition` and
  :ref:`suffix-search-condition`.
* Supported suffix search by index.
* [doc] Added a document about :doc:`/reference/grn_expr`.
* [munin] Supported JSON library installed by RubyGems [GitHub#17]
  [Patch by IWAI, Masaharu]
* [doc] Updated the description of how to specify a value as Time in tutorial.
  [#1405] [Reported by IWAI, Masaharu]
* [rpm] Removed groonga-tokenizer-mecab dependency from groonga package.
  [GitHub#18] [Patch by IWAI, Masaharu]

Fixes
^^^^^

* Fixed a problem that display of command prompt changes to not intended state
  by using batch mode on Mac OS X.
  [Reported by @soundkitchen]
* Fixed not to terminate after an invalid command in client mode. [#1305]
* Fixed a problem that '=R' is treated as 'OR' in ``--query`` syntax. [#1393]

Thanks
^^^^^^

* @soundkitchen
* IWAI, Masaharu

.. _release-2-0-3:

Release 2.0.3 - 2012/05/29
--------------------------

Improvements
^^^^^^^^^^^^

* [doc] Added about release procedure.
* Removed restriction that the max number of opened files is 4096.
* [experimental] Added table plugin.
* [doc] Added more descriptions about :doc:`/reference/commands/select` command.
* [doc] Made execution example copy & paste friendly.
* [windows] Supported build with Visual Studio 2010 Express and
  CMake. See :doc:`/install/windows` about details.
* [doc][solaris] Added a document about building on Solaris.
  See :doc:`/install/solaris` about details.
* [doc][yum] Updated epel-release package version.
  [Reported by IWAI, Masaharu]
* [doc][cenos6] Disabled Repoforge for Munin for CentOS 6.
  [Reported by IWAI, Masaharu]
* Started distributing source archive in zip format.
* [munin] groonga_dist Munin plugin supported an object that has
  separated files.
* Started using Travis CI.
* [yum] Changed RPM package name that provides yum repository from
  groonga-repository to groonga-release to follow RPM package name
  convension such as centos-release and fedora-release.

Fixes
^^^^^

* [doc] Fixed a command to update yum repository.
  [Suggested by IWAI, Masaharu]
* [deb] Fixed a bug that log_repoen command in logrotate uses wrong protocol.
* Fixed broken ERROR tag in XML response.
  [#1363] [GitHub#13] [Patch by IWAI, Masaharu]
* Fixed a bug that grn_ctx isn't fully cleared by grn_ctx_fin().
* Fixed a bug that ``&!`` set operation doesn't work with grouped
  expression. [#1372]
* Fixed a bug that a record key registered via index source isn't normalized.

Thanks
^^^^^^

* IWAI, Masaharu

.. _release-2-0-2:

Release 2.0.2 - 2012/04/29
--------------------------

.. caution::

   The package sign key is changed since this release. Import the new
   package sign key before updating groogna packages.

   Debian/Ubuntu::

     % sudo apt-get update
     % sudo apt-get -y --allow-unauthenticated install groonga-keyring

   CentOS/Fedora::

     % sudo yum makecache
     % sudo yum install --nogpgcheck -y groonga-repository

Improvements
^^^^^^^^^^^^

* [pkg-config] Removed needless MessagePack dependency.
* [rpm][fedora] Supported libedit. [#1325] [Suggested by IWAI, Masaharu]
* [rpm] Supported zlib and LZO. [#1324] [Patch by IWAI, Masaharu]
* [groonga] Improved daemoinzed timing. Groonga server daemonizes
  after socket is listened. It means that groonga server is ready when
  groonga server is daemonized. [#1326]
* [admin] Supported suggest in groonga administration page.
* [dump] Ignored MeCab tokenizer load error.
* Supported CMake.
* [load] Supported error report when a column value can't be set.
* Supported similar search. ``select --filter "column *S 'TEXT'"``
  is the similar search syntax. [#1342]
* [apt][yum] Changed package sign key.
* Supported Ubuntu Precise Pangolin.
* [apt] Added a new groonga-keyring deb package for the groonga's
  package sign key.

Fixes
^^^^^

* [deb][rpm] Used ``--bind-address`` option instead of deprecated
  ``--address`` option.
  [#1320] [Patch by IWAI, Masaharu]
* [deb] Renamed groonga-server package's configuration file to
  /etc/default/groonga-server from /etc/default/groonga.
* [rpm][fedora] Fixed upgrade condition in %post server.
  [GitHub#11] [Patch by Daiki Ueno]
* [rpm] Removed needless change logs. [#1328] [Patch by IWAI, Masaharu]
* [deb][rpm] Added missing curl dependency.
  [GitHub#12] [Patch by IWAI, Masaharu]
* [rpm] Removed needleess ruby package dependency from groonga package.
  [#1330] [Suggested by IWAI, Masaharu]
* [deb] Added missing default values to groonga-server's
  configuration file.
* Fixed a crash bug that is caused when searching with updaging very large
  inverted index. [#1329]
* Fixed a bug that strings are compared as characters instead of byte string.
  [#1340] [Reported by Shinya Kawaji]

Thanks
^^^^^^

* IWAI, Masaharu
* Daiki Ueno
* Shinya Kawaji

.. _release-2-0-1:

Release 2.0.1 - 2012/03/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported build in other directory.
  [#1298] [Reported by Kazuhiko]
* [solaris] Supported build on Solaris 11. [Reported by Kazuhiko]
* [test] Supported functional test.
* [test] Required ``--with-ruby19`` configure option for testing by Ruby.
* [dump] Supported records dump for a table that has default tokenizer.
* [suggest] Added ``similar_search`` option.
* [groonga] Removed deprecated options, ``-a``, ``--address`` and
  ``--admin-html-path``.
* Added more return value checks. [GitHub#9] [Reported by Markus Elfring]
* [dat] Supported term extract operation.
* Added `logos <http://groonga.org/logo/>`_ .
* Updated HTML design.
* Renamed ``grntest`` to ``groonga-benchmark``.
* Supported ``autogen.sh`` on CentOS 5.
* [linux] Added ``vm.overcommit_memory`` kernel parameter value
  check. [#1289]
* ``grn_snip`` uses ``grn_obj`` mechanism. [#1054]

Fixes
^^^^^

* Fixed a bug that uninstall task doesn't uninstall installed Ruby
  scripts. [#1299] [Reported by Kazuhiko]
* Added a missing Gemfile. [#1302] [Reported by Kazuhiko]
* Fixed a bug that some indexed records aren't found. The feature is
  only used by mroonga. [#1303]
* [groonga] Appended missing ``-id`` to ``--server-id`` option name.
* Fixed a bug that latin1 normalization may access unexpected memory.

Thanks
^^^^^^

* Kazuhiko
* Markus Elfring

.. _release-2-0-0:

Release 2.0.0 - 2012/02/29
--------------------------

Improvements
^^^^^^^^^^^^

* [dat] Added 0 length key check.
* [windows] Added missing GCC related DLLs. [groonga-dev,00686]
  [Reported by Suzuki]
* [php] Supported PHP 5.4. [Patch by Daiki Ueno]
* Updated FSF address. [Suggested by Daiki Ueno]
* [fedora] Supported systemd. [Patch by Daiki Ueno]
* [rpm][debian] Changed the default protocol to HTTP from gqtp.
* [rpm][centos] Supported status command.
* Removed needless ``:`` from log message.
* Removed deprecated grn_query. [#1247]
* Reduced needless grn_ctx_at() calls on creating table.
* [pat] Supported cache.
* [tokenizer] Improved tokenizer API.
* Accepted ``@`` as a valid name character.
* [tokenizer] Added a tokenizer based on
  `KyTea <http://www.phontron.com/kytea/>`_.
* Supported :doc:`offline index construction </reference/indexing>`.
* [tokenizer] Supported MeCab 0.993. [groonga-dev,00703]
  [Reported by Masaharu YOSHIOKA]
* [windows] Supported MessagePack.

Fixes
^^^^^

* [pat] Fixed a bug that the last node can't be found. [#1258]
* [doc] Fixed links in Japanese page. [Reported by @naoina]
* [doc] Fixed wrong the default value. [Reported by @naoina]
* Fixed a typo. [Reported by Kazuhiko]
* [http] Fixed a bug that ``load`` command error isn't cleared.
  [Reported by @wareohji]

Thanks
^^^^^^

* Suzuki
* Daiki Ueno
* @naoina
* Kazuhiko
* Masaharu YOSHIOKA
* @wareohji

.. _release-1-3-0:

Release 1.3.0 - 2012/01/29
--------------------------

Improvements
^^^^^^^^^^^^

* Supported dynamic DB key table change by
  GRN_DB_KEY=pat or GRN_DB_KEY=dat environment variable value.
* Added ``--with-default-db-key`` configure option that
  specifies the default DB key table.
* Supported "" value for geo point data types. It's interpreted as "0x0".
* Added column name to cast error message.
* Inhibit file information for stdin on load error.
* Enabled write-strings warnings and suppress those
  warnings. [Suggested by montywi]
* Marked MessagePack output format as supported. [#1215]
* Added ``const`` to ``void *`` of ``*_set_value()``.
* Enabled warning flags on C and C++.
* Supported ``--with-libevent`` without value configure option.
* ``grn_table_get()`` supported grn_db. [#1242]
* [rpm] Removed needless groogna-munin-plugins dependency
  from groonga-server. [#1251] [Suggested by Masaharu IWAI]
* [rpm] Removed needless groogna-doc dependency
  from groonga. [#1251] [Suggested by Masaharu IWAI]
* [dat] Supported repair by ``grn_dat_repair()``.
* ``grn_table_at()`` supported grn_db.
* [suggest] Removed unstable mark.
* [suggest][complete] Supported normalized value search in prefix-search.
* Added experimental offline index build. It's disabled by
  default for now. You can enable it by
  USE_OFFLINE_INDEXER=yes environment variable.
* Added internal API ``grn_obj_path_by_id()`` for mroonga.
* [suggest][httpd] Passed unknown parameters to groonga.
* [output][xml] Added a newline before ``</RESULT>`` for readability.
* [doc][output] Added documentation about output format type.
* Added ``table_rename``. [#1234]
* Added ``column_rename``. [#1234]

Thanks
^^^^^^

* montywi
* Masaharu IWAI

The old releases
----------------

.. toctree::
   :maxdepth: 2

   news/1.2.x
   news/1.1.x
   news/1.0.x
   news/0.x
   news/senna
